Subject: bug#74423: Low level key events

From: Cecilio Pardo <[email-masked]>
Date: Wed, 22 Jan 2025 21:57:25 +0100

On 04/01/2025 5:55, Stefan Monnier wrote:
>> You suggested to auto generate the keysym table, but we
>> would still need a table to relate the Windows keys to the X
>> equivalent.
> 
> I don't doubt some part has to be done manually, but I think we should
> strive to make it via code as much as possible.
> 
> E.g. on each platform we should try to provide a programmatic way to map
> the integer key to/from a meaningful system-specific string or symbol
> (at least, to the extent that the underlying system provides such
> a functionality).
> 
> Mapping between those symbols in different systems will likely be (at
> least partly) manual, inevitably, but I'm hoping this can be
> significantly smaller (especially I'm hoping we can "align" the
> system-specific symbols such that many are already identical between the
> different systems).
> 
> Finally it's not 100% indispensable to have unified symbols that work
> identically on all systems: users could also just use the system-specific
> names.  They'd need a mapping between them only for code/configuration
> that is used with different systems.  So it's only really important when
> those names start to be used in libraries.

This seems to be feasible for the three platforms I can work on (X, gtk 
and windows). Also the problem with pgtk not identifying modifiers was 
more a problem of ignorance on my part.

I'm working on this, will need some time.